VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "vbExt"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains useful functions that can be implemented in many programs."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Used in debug and trace calls.
Private Const MODULE_NAME As String = "vbExt"

Public Enum RegistryKey
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
End Enum

Public Enum OSType
    Unknown = 0
    Win95 = 1
    Win98 = 2
    WinNT351 = 3
    WinNT4 = 4
    Win2K = 5
    WinME = 6
End Enum

Private Enum LogType
    ltNoLog = 0
    ltEventLog = 1
    ltFileLog = 2
End Enum

Public Enum enDebugLevel
    endlTraceIn = 1
    endlDebug = 2
    endlTraceOut = 3
End Enum

Private mbLogThreadID As Boolean
Private mbLogOverwrite As Boolean
Private mltLogType As LogType
Private msLogName As String

Private msObjectID As String

'local variable(s) to hold property value(s)
Private mvarIsNT As Boolean 'local copy
Private mvarOsVersion As OSType 'local copy
Private mvarWindowsFolderName As String 'local copy
Private mvarSystemFolderName As String 'local copy
Private mvarTempFolderName As String 'local copy

Private oLogManager As COMTPWickes_InterOp_Implementation.LogManager

Public Property Get TempFolderName() As String
Attribute TempFolderName.VB_Description = "The path to the Temporary folderr with a trailing backslash (\\)."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.TempFolder
    TempFolderName = mvarTempFolderName
End Property

Public Property Get SystemFolderName() As String
Attribute SystemFolderName.VB_Description = "The path to the System folderr with a trailing backslash (\\)."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SystemFolder
    SystemFolderName = mvarSystemFolderName
End Property
Public Property Get WindowsFolderName() As String
Attribute WindowsFolderName.VB_Description = "The path to the Windows folder with a trailing backslash (\\)."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WindowsFolder
    WindowsFolderName = mvarWindowsFolderName
End Property
Public Property Get OsVersion() As OSType
Attribute OsVersion.VB_Description = "The version of Windows that is running."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.OsVersion
    OsVersion = mvarOsVersion
End Property
Public Property Get IsNT() As Boolean
Attribute IsNT.VB_Description = "True is the system is NT (3.5, 4.0 or W2K)"
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.IsNT
    IsNT = mvarIsNT
End Property
'   Create a new instance of our custom error object and pass a reference to it back to the
'   calling procedure.
'   If the cusrom error object already exists increment it's reference count.
'<CACH>****************************************************************************************
'* Sub:  CreateErrorObject()
'**********************************************************************************************
'* Description:
'*   Create Custom error object and pass a reference to it back to the calling procedure.
'*   If the custom error object already exists then increment it's reference count.
'**********************************************************************************************
'* Parameters:
'*In    :HostAppTitle   String. -name of app/component to log errors for
'*In/Out:HostVBAErr VBA.ErrObject. -references standard Err Object
'*In/Out:HostErrObject  vbUtils.ErrorObject. - reference App's Error object(create if Nothing)
'**********************************************************************************************
'* History:
'* 05/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub CreateErrorObject(ByVal HostAppTitle As String, _
                                  ByRef HostVBAErr As VBA.ErrObject, _
                                  ByRef HostErrObject As VbUtils_Wickes.ErrorObject)
Attribute CreateErrorObject.VB_Description = "Create a new instance of our custom error object (ErrorObject) and pass a reference to it back to the calling procedure.\r\nIf the cusrom error object already exists (i.e. HostErrObject is not nothing) increment it's reference count."

Const PROCEDURE_NAME As String = MODULE_NAME & ".CreateErrorObject"

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    'We need the Host App's title for registering the app for logging.
    If Len(HostAppTitle) = 0 Then
        'Use standard mechanism to raise an error. The template object creation code provided
        'is designed to handle such an occurrance.
        VBA.Err.Raise vbObjectError + 512 + 1, App.Title, _
                        "An application title must be supplied when creating an error object"
        
    End If

    
    'We need a connection to the Host's VBA error object so that we can access the details of the
    'any error that occurs (as opposed to any that we raise ourselves).
    If HostVBAErr Is Nothing Then
        'Use standard mechanism to raise an error. The template object creation code provided
        'is designed to handle such an occurrance.
        VBA.Err.Raise vbObjectError + 512 + 2, App.Title, _
                        "The VBA.Err error object must be supplied when creating an error object"
        
    End If
    
    
    If HostErrObject Is Nothing Then
        ' The custom error object doesn't exist so create it
           
        'Having received the two host objects we can now go ahead and create the Kalamazoo
        'error object for the host.
        Set HostErrObject = New ErrorObject
            
        'Connect the ErrorObject to the errors in the Host app.
        Set HostErrObject.HostVBAErr = HostVBAErr
        
        'Add reference to vbExt so that logging in the Report method works
        Set HostErrObject.HostVbExt = Me
    
    Else
        ' Use an existing custom error object so increment it's reference count
        HostErrObject.AddRef
    End If
    
    'Register this app for logging.
    Call RegisterAppForLogging(HostAppTitle)
    Call StartLogging(HostAppTitle, vbLogAuto)

End Sub 'CreateErrorObject
'<Auto-Procedure-Header>=======================================================================
' Sub:  DebugMsg
'
' Description: Sends debug information to external Listeners using API
'
'----------------------------------------------------------------------------------------------
' Arguments (Name, Type, Description):
' In:  sModuleName String - Name of module where debug message originated
' In:  sProcedureName String - Name of Procedere or Function where debug message originated
' In:  eMessageLevel eDebugLevel - Classification of Message as 1=Trace In
'                                                               2=Debug
'                                                               3=Trace Out
' In:  sMessageStr String (Optional) - the information to be sent to the listeners for
'      additional information to aid the debugging process
'----------------------------------------------------------------------------------------------
' Version History (When, Who, What):
' 27/05/2001    MauriceM
'               Initial Version
'</Auto-Procedure-Header>======================================================================
Public Sub DebugMsg(ByVal sModuleName As String, ByVal sProcedureName As String, ByVal eMessageLevel As enDebugLevel, Optional ByVal sMessageStr As String)

    Dim logStr As String
    logStr = sModuleName & vbTab & sProcedureName & vbTab & eMessageLevel & vbTab & sMessageStr
    
    OutputDebugString (logStr)
    
    On Error GoTo SkipAdvancedLogging
    
    If oLogManager Is Nothing Then
        Set oLogManager = New COMTPWickes_InterOp_Implementation.LogManager
    End If
        
    oLogManager.WriteLog (logStr)
    
SkipAdvancedLogging:

End Sub 'DebugMsg
'-----------------------------------------------------------
' FUNCTION: UnsignedToLong
' Convert an unsigned double to a long
'
' IN: [Value] - double to convert
'
' Returns : a long containing the signed value
'-----------------------------------------------------------
Function UnsignedToLong(Value As Double) As Long
Attribute UnsignedToLong.VB_Description = "Convert an unsigned double value to a long (with sign)."
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".UnsignedToLong"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If Value < 0 Or Value >= OFFSET_4 Then
        Error 6 ' Overflow
    ElseIf Value <= MAXINT_4 Then
        UnsignedToLong = Value
    Else
        UnsignedToLong = Value - OFFSET_4
    End If
    
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: LongToUnsigned
' Convert a long to a double and ignore the sign
'
' IN: [Value] - long to convert
'
' Returns : a double containing the unsigned value
'-----------------------------------------------------------
Function LongToUnsigned(Value As Long) As Double
Attribute LongToUnsigned.VB_Description = "Convert a long to a double and ignore the sign."
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".LongToUnsigned"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)
    
    If Value < 0 Then
        LongToUnsigned = Value + OFFSET_4
    Else
        LongToUnsigned = Value
    End If

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: UnsignedToInteger
' Convert an unsigned long to an integer
'
' IN: [Value] - long to convert
'
' Returns : an integer containing the value (now signed)
'-----------------------------------------------------------
Function UnsignedToInteger(Value As Long) As Integer
Attribute UnsignedToInteger.VB_Description = "Convert an unsigned long value to an integer (with sign)."
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".UnsignedToInteger"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If Value < 0 Or Value >= OFFSET_2 Then
        Error 6 ' Overflow
    ElseIf Value <= MAXINT_2 Then
        UnsignedToInteger = Value
    Else
        UnsignedToInteger = Value - OFFSET_2
    End If

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: IntegerToUnsigned
' Convert an integer to a long and ignore the sign
'
' IN: [Value] - integer to convert
'
' Returns : a long containing the unsigned value
'-----------------------------------------------------------
Function IntegerToUnsigned(Value As Integer) As Long
Attribute IntegerToUnsigned.VB_Description = "Convert an integer to a long and ignore the sign."
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".IntegerToUnsigned"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If Value < 0 Then
        IntegerToUnsigned = Value + OFFSET_2
    Else
        IntegerToUnsigned = Value
    End If

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'------------------------------------------------------------------------------------
' SUB: RegisterAppForLogging
' Update the EventLog section of the registry so that details are displayed correctly
' in the Event viewer
'
' IN: [AppName]     The name of the event source (VB application) as it is written to
'                   the EventLog
'------------------------------------------------------------------------------------
Public Sub RegisterAppForLogging(ByVal AppName As String)
Attribute RegisterAppForLogging.VB_Description = "Update the EventLog section of the registry so that entries for <AppName> that appear in the ""Application"" log will be formatted correctly."
Dim sAppPath As String
Dim sSection As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".RegisterAppForLogging"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    sAppPath = App.Path + "\" + App.EXEName + ".dll"
    sSection = EVENT_LOG + "\" + AppName
    SaveRegSetting sSection, "EventMessageFile", sAppPath, HKEY_LOCAL_MACHINE
    SaveRegSetting sSection, "TypesSupported", 4, HKEY_LOCAL_MACHINE
    
    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Sub
'------------------------------------------------------------------------------------
' SUB: LogEvent
' Add a message to a log.
' The log is defined by the "StartLogging" method.
'
' IN: [LogBuffer]   The text to add to the log
'     [EventType]   Optional. The type of event - defaults to Error.
'                   The text for the EventType is held in the RES file.
'------------------------------------------------------------------------------------
Public Sub LogEvent(ByVal LogBuffer As String, _
        Optional ByVal EventType As LogEventTypeConstants = vbLogEventTypeError)
Attribute LogEvent.VB_Description = "Add <Logbuffer> to the log.\r\nThe log is defined by the ""StartLogging"" method.\r\nThis method replaces the App.LogEvent method."
Dim lHandle As Long
Dim sEventString As String
Dim sThreadID As String
Dim bEventLogged As Boolean
Dim fsoFileSys As Scripting.FileSystemObject
Dim tsLogStream As Scripting.TextStream
Dim iomMode As IOMode
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".LogEvent"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    ' Convert the ThreadID to an unsigned double before converting it to
    ' a string as it is an unsigned long and VB doesn't understand unsigned
    sThreadID = CStr(LongToUnsigned(App.ThreadID))

    Select Case mltLogType
    Case ltEventLog
        ' Write to the NT Event log
        lHandle = RegisterEventSource(vbNullString, msLogName)
        If lHandle <> 0 Then
            ' Event source registered
            If mbLogThreadID = True Then
                sEventString = "Thread ID : " + sThreadID + vbCrLf + LogBuffer
            Else
                sEventString = LogBuffer
            End If
            If ReportEvent(lHandle, EventType, 0, 1, vbNullString, 1, 0, sEventString, vbNullString) <> 0 Then
            ' Event logged successfully
                bEventLogged = True
            Else
                bEventLogged = False
            End If
            DeregisterEventSource lHandle
        Else
            bEventLogged = False
        End If
        
        If bEventLogged = False Then
            ' Can't register the event source or log the event so use the App object
            ' to do the logging.
            ' This will create entries with "VBRunTime" as the event source.
            App.Title = msLogName
            App.StartLogging msLogName, vbLogAuto
            
            ' Log the fact that RegisterEventSource failed
            App.LogEvent vbCrLf + GetResMessage(rfsRegisterEventSourceError, Err.LastDLLError), _
                    vbLogEventTypeError
            
            ' Now log the actual error
            App.LogEvent vbCrLf + sEventString, vbLogEventTypeError
        End If

    Case ltFileLog
        ' Log to a file
        Set fsoFileSys = New Scripting.FileSystemObject
        Set tsLogStream = fsoFileSys.OpenTextFile(msLogName, ForAppending, True)
        If mbLogThreadID = True Then
            sEventString = "(Thread ID : " + sThreadID + ") " + LogBuffer
        Else
            sEventString = LogBuffer
        End If
        sEventString = Format$(Now, "yyyy/mm/dd hh:mm:ss ") + LoadResString(EventType) + " - " + sEventString
        tsLogStream.WriteLine sEventString
        tsLogStream.Close
        Set tsLogStream = Nothing
        Set fsoFileSys = Nothing

    End Select
    
    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
    
End Sub
'------------------------------------------------------------------------------------
' FUNCTION: GetLogFilePath
'
' Validate the extension (default to ".log") and path (default to the Windows directory)
' and return the full path.
'
' IN: [sLogFileName]    The name of the log file
'
' Returns: The validated full path and extension.
'------------------------------------------------------------------------------------
Private Function GetLogFilePath(sLogFileName As String) As String
Dim sExt As String
Dim iPos As Integer
Dim fsoFileSys As Scripting.FileSystemObject
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetLogFilePath"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    ' If sLogFileName doesn't include an extension then add ".log"
    Set fsoFileSys = New Scripting.FileSystemObject
    sExt = fsoFileSys.GetExtensionName(sLogFileName)
    If LenB(sExt) = 0 Then
        sLogFileName = sLogFileName + ".log"
    End If
    Set fsoFileSys = Nothing
            
    ' If LogTarget does not include a path then prefix it with mvarWindowsFolderName
    GetLogFilePath = sLogFileName
    iPos = InStr(1, sLogFileName, "/")
    If iPos = 0 Then
        iPos = InStr(1, sLogFileName, "\")
        If iPos = 0 Then
            GetLogFilePath = mvarWindowsFolderName + "\" & sLogFileName
        End If
    End If
    
    Exit Function

GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'------------------------------------------------------------------------------------
' SUB: StartLogging
' Define how and where data passed to the LogEvent method is written.
'
' IN: [LogTarget]   The name of the application doing the logging (NT EventLog) or
'                   the name of the file where the data is written.
'     [LogModes]    The type of log to use :
'                       vbLogAuto   - 0 (use EventLog on NT or file on Win9x)
'                       vbLogOff    - 1 (turn logging off)
'                       vbLogToFile - 2 (force logging to a file)
'                       vbLogToNT   - 3 (force logging to the EventLog)
'
'                   In addition the following two values can be added to the above :
'                       vbLogOverwrite  - 16 (overwrite the log file)
'                       vbLogThreadID   - 32 (include the thread ID in the log message)
'------------------------------------------------------------------------------------
Public Sub StartLogging(ByVal LogTarget As String, ByVal LogModes As LogModeConstants)
Attribute StartLogging.VB_Description = "Define how and where data passed to the ""LogEvent"" method is written.\r\nThis method replaces the App.StartLogging method and writes useful information to the NT Event Log.\r\nTo view data written to the NT Event Log using the EventViewer the application must first register itself with the Event Log using the ""RegisterAppForLogging"" method. This only needs to be done once."
Dim fsoFileSys As Scripting.FileSystemObject
Dim tsLogStream As Scripting.TextStream
Dim bLogOverwrite As Boolean
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".StartLogging"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If (LogModes And vbLogThreadID) > 0 Then
        mbLogThreadID = True
    Else
        mbLogThreadID = False
    End If
    
    If (LogModes And vbLogOverwrite) > 0 Then
        bLogOverwrite = True
    Else
        bLogOverwrite = False
    End If
    
    If LenB(LogTarget) = 0 Then
        LogTarget = "VBRuntime"
    End If
    
    ' Strip off optional settings and determine the the type of logging to use
    LogModes = LogModes And &HF
    Select Case LogModes
    Case vbLogAuto
        ' If NT then log to the Event Log else log to a file
        If mvarIsNT = True Then
            mltLogType = ltEventLog
            msLogName = LogTarget
        Else
            mltLogType = ltFileLog
            msLogName = GetLogFilePath(LogTarget)
            If bLogOverwrite = True Then
                ' Overwrite the existing log file
                Set fsoFileSys = New Scripting.FileSystemObject
                Set tsLogStream = fsoFileSys.CreateTextFile(msLogName, True)
                tsLogStream.Close
                Set tsLogStream = Nothing
                Set fsoFileSys = Nothing
            End If
        End If
        
    Case vbLogOff
        ' Turn logging off
        mltLogType = ltNoLog
    
    Case vbLogToFile
        ' Force logging to a file
        mltLogType = ltFileLog
        msLogName = GetLogFilePath(LogTarget)
        
        If bLogOverwrite = True Then
            ' Overwrite the existing log file
            Set fsoFileSys = New Scripting.FileSystemObject
            Set tsLogStream = fsoFileSys.CreateTextFile(msLogName, True)
            tsLogStream.Close
            Set tsLogStream = Nothing
            Set fsoFileSys = Nothing
        End If
        
    Case vbLogToNT
        ' Force logging to the NT Event Log
        ' If not running on NT then disable logging
        If mvarIsNT = True Then
            mltLogType = ltEventLog
            msLogName = LogTarget
        Else
            mltLogType = ltNoLog
        End If
    
    End Select
    
    Exit Sub

GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
    
End Sub
'----------------------------------------------------------------------------------
' FUNCTION: FormatRegErrorMessage
'
' Add the full registry key and error number returned from the API call to the
' RegAccessError message
'
' IN: [rkBaseKey]     - The base key
'     [sKey]          - The registry key
'     [sComputerName] - The computer name ("" if the local machine)
'     [iErrNo]        - The error number returned from the API call
'
' Returns : An error message containing the full key and the API error number.
'----------------------------------------------------------------------------------
Private Function FormatRegErrorMessage(rkBaseKey As RegistryKey, sKey As String, _
        sComputerName As String, lErrNo As Long) As String

Dim sFullKeyName As String
Dim colMoreInfo  As Collection
Dim sErrSource   As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".FormatRegErrorMessage"

    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    Select Case rkBaseKey
    Case HKEY_CLASSES_ROOT
        sFullKeyName = "HKEY_CLASSES_ROOT\"
    Case HKEY_CURRENT_USER
        sFullKeyName = "HKEY_CURRENT_USER\"
    Case HKEY_LOCAL_MACHINE
        sFullKeyName = "HKEY_LOCAL_MACHINE\"
    Case HKEY_USERS
        sFullKeyName = "HKEY_USERS\"
    End Select
        
    sFullKeyName = sFullKeyName + sKey
    If LenB(sComputerName) <> 0 Then
        If Left$(sComputerName, 2) = "\\" Then
            sFullKeyName = sComputerName + "\" + sFullKeyName
        Else
            sFullKeyName = "\\" + sComputerName + "\" + sFullKeyName
        End If
    End If
    
    Set colMoreInfo = New Collection
    colMoreInfo.Add sFullKeyName
    colMoreInfo.Add lErrNo
    FormatRegErrorMessage = GetResMessage(rfsRegAccessError, colMoreInfo)
    
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: GetRegSetting
' Get a setting from the registry
'
' IMPORTANT : Function only supports DWORD, STRING and EXPAND_STRING registry data
' IMPORTANT : If the key has any other data type then the [Default] value is returned
'
' IN: [Section] - The path to the registry section excluding the initial key
'     [Key]     - The key whose value we want to retrieve
'     [Default] - The value to return is the key doesn't exist
'     [BaseKey] - The base registry key (defaults to HKEY_CURRENT_USER)
'     [ComputerName]- Optional. The name of the computer to open the registry on.
'                     Defaults to the local computer.
'     [ErrorIfSectionMissing] - If False (the default) then do not generate an error
'                               if the <Section> is missing.
'
' Returns : The value of the registry key
'-----------------------------------------------------------
Function GetRegSetting(Section As String, Key As String, Optional Default As Variant = vbNullString, _
    Optional BaseKey As RegistryKey = HKEY_CURRENT_USER, Optional ComputerName As String = vbNullString, _
    Optional ErrorIfSectionMissing As Boolean = False) As Variant
Attribute GetRegSetting.VB_Description = "Return the value of the registry key <Key> as a string.\r\nIf <ComputerName> is not supplied then use the local registry.\r\n\r\nOnly STRING, DWORD and BINARY registry data types are supported."

Dim lKeyHandle As Long
Dim lRetVal As Long
Dim lDataType As Long
Dim lDataSize As Long
Dim sTempStr As String
Dim sExpandTempStr As String
Dim lTempValue As Long
Dim bytTempValue() As Byte
Dim sErrMsg As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetRegSetting"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    GetRegSetting = Default
    
    If LenB(ComputerName) = 0 Then
        lKeyHandle = BaseKey
        lRetVal = 0
    Else
        lRetVal = RegConnectRegistry(ComputerName, BaseKey, lKeyHandle)
    End If
    ' Open the key
    If lRetVal = 0 Then
        lRetVal = RegOpenKeyEx(lKeyHandle, Section, 0, KEY_READ, lKeyHandle)
    End If
    If lRetVal = 0 Then
        If RegQueryValueEx(lKeyHandle, Key, 0, lDataType, ByVal 0, lDataSize) = 0 Then
            Select Case lDataType
                Case REG_SZ
                    ' Normal string data
                    If lDataSize > 0 Then
                        sTempStr = String(lDataSize, Chr$(0))
                        If RegQueryValueEx(lKeyHandle, Key, 0, _
                                lDataType, ByVal sTempStr, lDataSize) = 0 Then
                            GetRegSetting = Left$(sTempStr, lDataSize - 1)
                        End If
                    Else
                        GetRegSetting = vbNullString
                    End If
                Case REG_EXPAND_SZ
                    ' String data with env variables that needs expanding
                    sTempStr = String(lDataSize + 1, Chr$(0))
                    If RegQueryValueEx(lKeyHandle, Key, 0, lDataType, _
                            ByVal sTempStr, lDataSize) = 0 Then
                        sExpandTempStr = String(256, Chr$(0))
                        ' Expand the string
                        lRetVal = ExpandEnvironmentStrings(sTempStr, sExpandTempStr, 256)
                        If lRetVal > 256 Then
                            ' String > 256 bytes long so create one big enough
                            sExpandTempStr = String(lRetVal, Chr$(0))
                            lRetVal = ExpandEnvironmentStrings(sTempStr, sExpandTempStr, 256)
                        End If
                        If lRetVal <> 0 Then
                            GetRegSetting = sExpandTempStr
                        End If
                    End If
                Case REG_BINARY
                    ' Binary data
                    ReDim bytTempValue(lDataSize - 1)
                    If RegQueryValueEx(lKeyHandle, Key, 0, _
                                lDataType, bytTempValue(0), lDataSize) = 0 Then
                        GetRegSetting = bytTempValue
                    End If
                Case REG_DWORD
                    ' 4 byte word
                    If RegQueryValueEx(lKeyHandle, Key, 0, _
                                lDataType, lTempValue, lDataSize) = 0 Then
                        GetRegSetting = lTempValue
                    End If
            End Select
        End If
    Else
        If lRetVal = 5 Then
            ' Permission denied
            sErrMsg = FormatRegErrorMessage(BaseKey, Section + "\" + Key, ComputerName, lRetVal)
            Err.Raise 70, PROCEDURE_NAME, sErrMsg
        Else
        ' Section is missing
            If ErrorIfSectionMissing = True Then
                sErrMsg = FormatRegErrorMessage(BaseKey, Section + "\" + Key, ComputerName, lRetVal)
                Err.Raise 335, PROCEDURE_NAME, sErrMsg
            End If
        End If
    End If
                
    Exit Function

GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
    
End Function
'-----------------------------------------------------------
' FUNCTION: GetAllRegSettings
' Get all settings from a registry key
'
' IMPORTANT : Function only supports BINARY, DWORD, STRING and EXPAND_STRING registry data
'
' IN: [Key]         - The key whose value we want to retrieve
'     [BaseKey]     - Optional. The base registry key.
'                     Defaults to HKEY_CURRENT_USER)
'     [ComputerName]- Optional. The name of the computer to open the registry on.
'                     Defaults to the local computer.
'
' Returns : A RegSettings collection object containing all data (excluding sub-keys) for the key
'-----------------------------------------------------------
Function GetAllRegSettings(Key As String, Optional BaseKey As RegistryKey = HKEY_CURRENT_USER, _
        Optional ComputerName As String = vbNullString) As RegSettings
Attribute GetAllRegSettings.VB_Description = "Get all the values for <Key> from the registry.\r\nIf <ComputerName> is not supplied then use the local registry.\r\nOnly STRING, DWORD and BINARY registry data types are supported.\r\nReturns a ""RegSettings"" collection of ""RegSetting"" objects."
Dim lKeyHandle As Long
Dim lRetVal As Long
Dim lMaxNameSize As Long
Dim lMaxDataSize As Long
Dim lDataType As Long
Dim sTempName As String
Dim sName As String
Dim bytData() As Byte
Dim lCurrentValue As Long
Dim lNameSize As Long
Dim lDataSize As Long
Dim sTempStr As String
Dim sExpandTempStr As String
Dim lTempLong As Long
Dim bytTempByte() As Byte
Dim rgsRegSettings As RegSettings
Dim sErrMsg As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetAllRegSettings"
 
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

        
    If LenB(ComputerName) = 0 Then
        lKeyHandle = BaseKey
        lRetVal = 0
    Else
        lRetVal = RegConnectRegistry(ComputerName, BaseKey, lKeyHandle)
    End If
    ' Open the key
    If lRetVal = 0 Then
        lRetVal = RegOpenKeyEx(lKeyHandle, Key, 0, KEY_QUERY_VALUE, lKeyHandle)
    End If
    If lRetVal = 0 Then
        ' Get the max lengths for the Name and Value fields
        lRetVal = RegQueryInfoKey(lKeyHandle, 0, 0, 0, 0, 0, 0, 0, lMaxNameSize, lMaxDataSize, 0, 0)
        If lRetVal = 0 Then
            ' Allocate temp storage for data retrieved from the registry
            lMaxNameSize = lMaxNameSize + 1
            lMaxDataSize = lMaxDataSize + 1
            sTempName = String(lMaxNameSize, 0)
            ReDim bytData(lMaxDataSize)
            
            Set rgsRegSettings = New RegSettings
            lCurrentValue = 0
            ' Loop round getting all keys and values
            Do While lRetVal = 0
                lNameSize = lMaxNameSize
                lDataSize = lMaxDataSize
                lRetVal = RegEnumValue(lKeyHandle, lCurrentValue, sTempName, lNameSize, 0, _
                            lDataType, bytData(0), lDataSize)
                If lRetVal = ERROR_NO_MORE_ITEMS Then
                    ' All values found
                    lRetVal = 0
                    Exit Do
                ElseIf lRetVal = 0 Then
                    ' Strip the NULL terminator
                    sName = Left$(sTempName, lNameSize)
                    Select Case lDataType
                    Case REG_SZ
                        ' Normal string data
                        If lDataSize > 0 Then
                            ' Copy the byte array to a string
                            sTempStr = String(lDataSize - 1, 0)
                            CopyMemory ByVal sTempStr, bytData(0), lDataSize - 1
                            rgsRegSettings.Add sName, stString, sTempStr
                        Else
                            rgsRegSettings.Add sName, stString, vbNullString
                        End If
                    Case REG_EXPAND_SZ
                        ' String data with env variables that needs expanding
                        ' Copy the byte array to a string
                        sTempStr = String(lDataSize - 1, 0)
                        CopyMemory ByVal sTempStr, bytData(0), lDataSize - 1
                        sExpandTempStr = String(256, Chr$(0))
                        ' Expand the string
                        lRetVal = ExpandEnvironmentStrings(CStr(bytData), sExpandTempStr, 256)
                        If lRetVal > 256 Then
                            ' String > 256 bytes long so create one big enough
                            sExpandTempStr = String(lRetVal, Chr$(0))
                            lRetVal = ExpandEnvironmentStrings(sTempStr, sExpandTempStr, 256)
                        End If
                        If lRetVal <> 0 Then
                            ' Strip the NULL terminator
                            sExpandTempStr = Left$(sExpandTempStr, lRetVal - 1)
                            rgsRegSettings.Add sName, stString, sExpandTempStr
                        Else
                            Exit Do
                        End If
                    Case REG_BINARY
                        ' Binary data
                        ReDim bytTempByte(lDataSize - 1)
                        CopyMemory bytTempByte(0), bytData(0), lDataSize
                        rgsRegSettings.Add sName, stByteArray, bytTempByte
                    Case REG_DWORD
                        ' 4 byte word
                        CopyMemory lTempLong, bytData(0), 4
                        rgsRegSettings.Add sName, stLong, lTempLong
                    End Select
                Else
                    Exit Do
                End If
                lCurrentValue = lCurrentValue + 1
            Loop
        End If
    End If
    
    RegCloseKey lKeyHandle
    
    If lRetVal <> 0 Then
        'Error
        Set rgsRegSettings = Nothing
        sErrMsg = FormatRegErrorMessage(BaseKey, Key, ComputerName, lRetVal)
        If lRetVal = 5 Then
            ' Permission denied
            Err.Raise 70, PROCEDURE_NAME, sErrMsg
        Else
            Err.Raise 335, PROCEDURE_NAME, sErrMsg
        End If
    End If
    
    Set GetAllRegSettings = rgsRegSettings
    Set rgsRegSettings = Nothing

    Exit Function

GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: GetAllRegSubKeys
' Get all the subkeys associated with a registry key
' If the registry key cannot be opened or a subkey cannot be read
' then ERR 335 is raised.
''
' IN: [[Key]     - The key to open
'     [BaseKey] - The base registry key (defaults to HKEY_CURRENT_USER)
'     [ComputerName]- Optional. The name of the computer to open the registry on.
'                     Defaults to the local computer.
'
' Returns : A RegSettings collection object containing all sub-keys for the key
'-----------------------------------------------------------
Public Function GetAllRegSubKeys(Key As String, Optional BaseKey As RegistryKey = HKEY_CURRENT_USER, _
    Optional ComputerName As String = vbNullString) As RegSettings
Attribute GetAllRegSubKeys.VB_Description = "Get all the sub-keys for <Key> from the registry.\r\nIf <ComputerName> is not supplied then use the local registry.\r\nReturns a ""RegSettings"" collection of ""RegSetting"" objects."

Dim lRetVal As Long
Dim lKeyHandle As Long
Dim sTemp As String * 256
Dim lSubKeyLength As Long
Dim iIndex As Integer
Dim rgsRegSettings As RegSettings
Dim sErrMsg As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetAllRegSubKeys"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If LenB(ComputerName) = 0 Then
        lKeyHandle = BaseKey
        lRetVal = 0
    Else
        lRetVal = RegConnectRegistry(ComputerName, BaseKey, lKeyHandle)
    End If
    ' Open the key
    If lRetVal = 0 Then
        lRetVal = RegOpenKeyEx(lKeyHandle, Key, 0, KEY_ENUMERATE_SUB_KEYS, lKeyHandle)
    End If
    If lRetVal = 0 Then
        ' Loop through the key looking for sub keys
        ' When a sub key is found add it to the array
        Set rgsRegSettings = New RegSettings
        iIndex = 0
        Do While lRetVal = 0
            lSubKeyLength = 256
            lRetVal = RegEnumKeyEx(lKeyHandle, iIndex, sTemp, lSubKeyLength, _
                            0, vbNullString, ByVal 0, ByVal vbNullString)
            If lRetVal = ERROR_NO_MORE_ITEMS Then
                ' All sub keys found
                Exit Do
            ElseIf lRetVal = 0 Then
                rgsRegSettings.Add Left$(sTemp, lSubKeyLength), stKey
                iIndex = iIndex + 1
            Else
                Exit Do
            End If
        Loop
        RegCloseKey lKeyHandle
    ElseIf lRetVal = 5 Then
        sErrMsg = FormatRegErrorMessage(BaseKey, Key, ComputerName, lRetVal)
        ' Permission denied
        Err.Raise 70, PROCEDURE_NAME, sErrMsg
    ElseIf lRetVal <> ERROR_FILE_NOT_FOUND Then
        ' If the key doesn't exist then OK else return the error
        sErrMsg = FormatRegErrorMessage(BaseKey, Key, ComputerName, lRetVal)
        Err.Raise 335, PROCEDURE_NAME, sErrMsg
    End If
    
    Set GetAllRegSubKeys = rgsRegSettings
    Set rgsRegSettings = Nothing
    
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' SUB: SaveRegSetting
' Save a settiny in the registry
' If the registry key cannot be opened or the key cannot be saved
' then ERR 335 is raised.
'
' IMPORTANT : The [Setting] is always saved as a string
'
' IN: [Section] - The path to the registry section excluding the initial key
'     [Key]     - The key whose value we want to set
'     [Setting] - The key value to save
'     [BaseKey] - The base registry key (defaults to HKEY_CURRENT_USER)
'     [ComputerName]- Optional. The name of the computer to open the registry on.
'                     Defaults to the local computer.
'-----------------------------------------------------------
Sub SaveRegSetting(Section As String, Key As String, Setting As Variant, _
    Optional BaseKey As RegistryKey = HKEY_CURRENT_USER, _
    Optional ComputerName As String = vbNullString)
Attribute SaveRegSetting.VB_Description = "Save the valuie for <Key> in the registry.\r\nIf <ComputerName> is not supplied then use the local registry.\r\n"
Dim lKeyHandle As Long
Dim lRetVal As Long
Dim sErrMsg As String
Dim bytValue() As Byte
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".SaveRegSetting"

    On Error GoTo GeneralErrorHandler

'    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)
    
    If LenB(ComputerName) = 0 Then
        lKeyHandle = BaseKey
        lRetVal = 0
    Else
        lRetVal = RegConnectRegistry(ComputerName, BaseKey, lKeyHandle)
    End If
    
    If lRetVal = 0 Then
        lRetVal = RegCreateKeyEx(lKeyHandle, Section, 0, vbNullString, REG_OPTION_NON_VOLATILE, _
                    KEY_ALL_ACCESS, vbNullString, lKeyHandle, ByVal 0)
    End If
    If lRetVal = 0 Then
        ' Determine the type of data to be saved
        Select Case TypeName(Setting)
        Case "Integer", "Long"
            ' DWORD
            lRetVal = RegSetValueEx(lKeyHandle, Key, 0, REG_DWORD, CLng(Setting), 4)
        Case "Byte()"
            ' Binary data
            bytValue = Setting
            lRetVal = RegSetValueEx(lKeyHandle, Key, 0, REG_BINARY, bytValue(0), UBound(Setting) + 1)
        Case "String"
            ' String
            If LenB(Setting) = 0 Then
                lRetVal = RegSetValueEx(lKeyHandle, Key, 0, REG_SZ, ByVal vbNullString, 1)
            Else
                lRetVal = RegSetValueEx(lKeyHandle, Key, 0, REG_SZ, ByVal CStr(Setting), _
                            Len(Setting) + 1)
            End If
        Case Else
            ' Unsupported type - raise a "Type mismatch" error
            Err.Raise 13
        End Select
    End If
    
    RegCloseKey lKeyHandle
    
    If lRetVal <> 0 Then
        sErrMsg = FormatRegErrorMessage(BaseKey, Key, ComputerName, lRetVal)
        Err.Raise 335, PROCEDURE_NAME, sErrMsg
    End If
    
    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Sub
'-----------------------------------------------------------
' SUB: RemoveRegKey
' Delete a Key and all subkeys or a value from the registry
' If the registry key cannot be opened or the Value cannot be deleted
' then ERR 335 is raised.
'
' IMPORTANT : All subkeys must be deleted before a Key can be deleted
'             so this function is called recursively
'
' IN: [Key]         - The Key to delete (or where the "value" is held)
'     [Value]       - Optional. The Value within the key to delete. Defaults to ""
'     [BaseKey]     - Optional. The base registry Value (defaults to HKEY_CURRENT_USER)
'     [ComputerName]- Optional. The name of the computer to open the registry on.
'                     Defaults to the local computer.
'-----------------------------------------------------------
Public Sub RemoveRegKey(Key As String, Optional Value As String = vbNullString, _
        Optional BaseKey As RegistryKey = HKEY_CURRENT_USER, Optional ComputerName As String = vbNullString)
Attribute RemoveRegKey.VB_Description = "Remove <Key> or <Value> from the registry.\r\nIf <Value> is not supplied then <Key> and all it's values and sub-keys will be deleted.\r\nIf <ComputerName> is not supplied then use the local registry."
Dim lRetVal As Long
Dim lKeyHandle As Long
Dim lBaseKeyHandle As Long
Dim sTemp As String * 256
Dim sSubKey As String
Dim lSubKeyLength As Long
Dim sErrMsg As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".RemoveRegKey"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    If LenB(ComputerName) = 0 Then
        lBaseKeyHandle = BaseKey
        lRetVal = 0
    Else
        lRetVal = RegConnectRegistry(ComputerName, BaseKey, lBaseKeyHandle)
    End If
    
    If lRetVal = 0 Then
        lRetVal = RegOpenKeyEx(lBaseKeyHandle, Key, 0, _
                    KEY_ENUMERATE_SUB_KEYS Or DELETE Or KEY_SET_VALUE, lKeyHandle)
    End If
    If lRetVal = 0 Then
        If LenB(Value) = 0 Then
        ' Delete a Value and all it's sub-keys
            ' Loop through the Value looking for sub keys
            ' When a sub Value is found call this function to delete it
            Do While lRetVal = 0
                lSubKeyLength = 256
                lRetVal = RegEnumKeyEx(lKeyHandle, 0, sTemp, lSubKeyLength, _
                                0, vbNullString, ByVal 0, ByVal vbNullString)
                If lRetVal = ERROR_NO_MORE_ITEMS Then
                    ' All sub keys deleted so delete this Value
                    lRetVal = RegDeleteKey(lBaseKeyHandle, Key)
                    Exit Do
                ElseIf lRetVal = 0 Then
                    sSubKey = Left$(sTemp, lSubKeyLength)
                    ' Don't need to supply the computer name
                    RemoveRegKey sSubKey, vbNullString, lKeyHandle, vbNullString
                Else
                    Exit Do
                End If
            Loop
        Else
            ' Delete a value
            lRetVal = RegDeleteValue(lKeyHandle, Value)
        End If
        RegCloseKey lKeyHandle
    End If
    If lRetVal = ERROR_FILE_NOT_FOUND Then
        ' Value doesn't exist so ignore the error
        lRetVal = 0
    End If
    
    If lRetVal <> 0 Then
        sErrMsg = FormatRegErrorMessage(BaseKey, Value, ComputerName, lRetVal)
        Err.Raise 335, PROCEDURE_NAME, sErrMsg
    End If
    
    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Sub
'----------------------------------------------------------------------------------
' FUNCTION: PopulateString
'
' Populate a string with additional information
' Substitute fields in the string with date from "MoreInfo".
' The fields to replace in the message is identified by a "%" sign
' followed by a field type identifier ('s' = string, 'd' = date, "n" = numeric)
' If multiple fields are to me replaced then "MoreInfo" must be a collection
'
' IN: [Message]  - The string to populate
'     [MoreInfo] - The additional data
'
' Returns : A string containing the populated message
'----------------------------------------------------------------------------------
Public Function PopulateString(Message As String, MoreInfo As Variant)
Attribute PopulateString.VB_Description = "Populate a string with additional information.\r\nSubstitute fields in the string with date from ""MoreInfo"".\r\nThe fields to replace in the message is identified by a ""%"" sign followed by a field type identifier ('s' = string, 'd' = date, ""n"" = numeric).\r\nIf multiple fields are to be replaced then ""MoreInfo"" must be a collection.\r\n"
Dim iPos As Integer
Dim vExtraData As Variant
Dim sTemp As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".PopulateString"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    iPos = 1
    
    If TypeName(MoreInfo) = "Collection" Then
        For Each vExtraData In MoreInfo
            sTemp = AddMoreInfo(Message, vExtraData, iPos)
            PopulateString = PopulateString + sTemp
            If iPos = 0 Then
                Exit For
            End If
        Next
    Else
        PopulateString = AddMoreInfo(Message, MoreInfo, iPos)
    End If
    
    If iPos > 0 Then
        ' Copy the remainder of the string
        PopulateString = PopulateString + Mid$(Message, iPos)
    End If

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'----------------------------------------------------------------------------------
' FUNCTION: AddMoreInfo
'
' Replace a paramater in a string with a value
'
' IN: [sMessage]  - The string to populate
'     [vMoreInfo] - The additional data
'     [iStartPos] - The position in the string to start looking for the "%" char
'
' OUT:[iStartPos] - The position in the string to start the next search for a
'                   "%" character or 0 is no "%" char found.
'
' Returns : A string populated with the additional value.
'----------------------------------------------------------------------------------
Private Function AddMoreInfo(ByVal sMessage As String, ByVal vMoreInfo As Variant, ByRef iStartPos As Integer)
Dim iPos As Integer
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddMoreInfo"

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    On Error GoTo GeneralErrorHandler
    
    iPos = InStr(iStartPos, sMessage, "%")
    If iPos = 0 Then
        ' Not found so copy whole string
        AddMoreInfo = Mid$(sMessage, iStartPos)
    Else
        ' Copy sMessage text to the left of '%x'
        AddMoreInfo = Mid$(sMessage, iStartPos, iPos - iStartPos)
        ' Determine what type of variable is being replaced
        Select Case Mid$(sMessage, iPos + 1, 1)
        Case "s"
            ' String
            AddMoreInfo = AddMoreInfo + vMoreInfo
        Case "d"
            ' Date
            AddMoreInfo = AddMoreInfo + Format$(vMoreInfo, "dd mmm yyyy")
        Case "n"
            ' Numeric
            AddMoreInfo = AddMoreInfo + CStr(vMoreInfo)
        Case Else
            ' Don't know what this is so just copy the character after the "%"
            AddMoreInfo = AddMoreInfo + Mid$(sMessage, iPos + 1, 1)
        End Select
        ' show where to start the next search from
        iStartPos = iPos + 2
    End If


    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'----------------------------------------------------------------------------------
' FUNCTION: GetResMessage
'
' Get a message from the RES file and populate any additional fields
'
' IN: [lMsgNo]    - The string number in the RES file
'     [vMoreInfo] - Optional. The additional data
'
' Returns : A string populated with the additional values.
'----------------------------------------------------------------------------------
Private Function GetResMessage(lMsgNo As Long, Optional vMoreInfo)
Dim sMsg As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetResMessage"

    On Error GoTo GeneralErrorHandler
    
    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    ' Get the error message from the resource file
    sMsg = LoadResString(lMsgNo)
    If LenB(sMsg) = 0 Then
        ' No message so use the default error message
        sMsg = LoadResString(rfsGeneralError)
        vMoreInfo = lMsgNo
    End If
        
      
    If IsMissing(vMoreInfo) = False Then
        ' Add additional info to the mesage string
        sMsg = PopulateString(sMsg, vMoreInfo)
    End If
    
    GetResMessage = sMsg
    

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceOut)

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

End Function
'-----------------------------------------------------------
' FUNCTION: StringFromBuffer
'
' Removes a trailing Null and / or CR (and anything after it)
' from a string returned by an API call
'
' IN: [Buffer] - string returned from an API call
'
' OUT:
'   A VB string containing only the valid characters
'-----------------------------------------------------------
Public Function StringFromBuffer(ByVal Buffer As String) As String
Attribute StringFromBuffer.VB_Description = "Removes a trailing Null and / or CR (and anything after it) from a string returned by an API call.\r\nReturns a new string."
Dim nPos As Long
Dim sTemp As String
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".StringFromBuffer"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    nPos = InStr(Buffer, Chr$(0))
    If nPos > 0 Then
        sTemp = Left$(Buffer, nPos - 1)
    Else
        sTemp = Buffer
    End If
    
    nPos = InStr(sTemp, vbCr)
    If nPos > 0 Then
        StringFromBuffer = Left$(sTemp, nPos - 1)
    Else
        StringFromBuffer = sTemp
    End If

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Function
'-----------------------------------------------------------
' FUNCTION: SplitString
' Split a string into sub-strings based on a delimiter character(s).
' This function is similar to the VBA function Split but with three
' important differences :
' 1. Sequences of the delimiter characer are treated as one delimiter (e.g. 2 spaces
'    is the same as 1 space and does not result in an empty token being returned)
' 2. Delimeter characters inside a double-quoted string are ignored (the string must
'    start and finish with a double quote character).
' 3. If a sub-string is enclosed in double-quotes then they are removed.
'
' IN: [Expression] - A string to be split up
'     [Delimiter]  - The character(s) used to delimit the sub-strings (defaults
'                    to space)
'
' OUT: A zero based string array of the sub strings
'-----------------------------------------------------------
Public Function SplitString(Expression As String, Optional Delimiter As String = " ") As Collection
Attribute SplitString.VB_Description = "Split a string into sub-strings based on a delimiter character(s).\r\nThis function is similar to the VBA function Split but with four important differences :\r\n1. It returns a collection of sub-strings.\r\n2. Sequences of the delimiter characer are treated as one delimiter (e.g. 2 spaces is the same as 1 space and does not result in an empty token being returned)\r\n3. Delimeter characters inside a double-quoted string are ignored (the string must start and finish with a double quote character).\r\n4. If a sub-string is enclosed in double-quotes then they are removed."
Dim sTmp As String
Dim sRemainder As String
Dim sSubStrings() As String
Dim iCount As Integer
Dim iDelimiterLen As Integer
Dim sDoubleQuote As String
Dim iNextQuote As Integer
Dim iNextDelimiter As Integer
Dim iNextSubString As Integer
Dim colResults As Collection
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".SplitString"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    sDoubleQuote = Chr$(34)
    iDelimiterLen = Len(Delimiter)
    iCount = 0
    Set colResults = New Collection
    
    sRemainder = Expression
    ReDim sSubStrings(0)
    Do While LenB(sRemainder) <> 0
        If StrComp(Left$(sRemainder, iDelimiterLen), Delimiter, vbBinaryCompare) = 0 Then
            colResults.Add vbNullString
            'iCount = iCount + 1
            'ReDim Preserve sSubStrings(iCount)
            'sSubStrings(iCount) = vbnullstring
            sRemainder = Mid$(sRemainder, iDelimiterLen + 1)
        Else
            If Left$(sRemainder, 1) = sDoubleQuote Then
                iNextQuote = InStr(2, sRemainder, sDoubleQuote, vbBinaryCompare)
                If iNextQuote = 0 Then
                    iNextQuote = Len(sRemainder)
                End If
                sTmp = Mid$(sRemainder, 1, iNextQuote)
                If Left$(sTmp, 1) = sDoubleQuote Then
                    sTmp = Mid$(sTmp, 2)
                End If
                If Right$(sTmp, 1) = sDoubleQuote Then
                    sTmp = Left$(sTmp, Len(sTmp) - 1)
                End If
                ' allow for the 2 double quotes when calculating where the next
                ' sub-string may start
                iNextSubString = Len(sTmp) + 2 + iDelimiterLen
            Else
                iNextDelimiter = InStr(1, sRemainder, Delimiter, vbBinaryCompare)
                If iNextDelimiter = 0 Then
                    ' This is the last token
                    sTmp = sRemainder
                Else
                    sTmp = Mid$(sRemainder, 1, iNextDelimiter - 1)
                End If
                iNextSubString = Len(sTmp) + iDelimiterLen
            End If
            'sSubStrings(iCount) = sTmp
            colResults.Add sTmp
            sRemainder = Mid$(sRemainder, iNextSubString + 1)
        End If
    Loop
    
    Set SplitString = colResults
    
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
    
End Function
'-----------------------------------------------------------
' SUB: Wait
'
' Waits for the specified number of seconds without comsuming
' CPU resource.
'
' IN: [Seconds] - The number of seconds to wait
'-----------------------------------------------------------
Public Sub Wait(ByVal Seconds As Integer)
Attribute Wait.VB_Description = "Waits for the specified number of seconds without comsuming CPU resource."
Dim iCount As Integer
Dim sglTimeNow As Single
Dim sglTargetTime As Single
Dim sglLastTime As Single
Dim bSameDay As Boolean
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".Wait"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    sglTimeNow = Timer()
    sglLastTime = sglTimeNow
    sglTargetTime = sglTimeNow + Seconds
    
    ' Check for going past midnight
    If sglTargetTime >= 86400 Then
        sglTargetTime = sglTargetTime - 86400
        bSameDay = False
    Else
        bSameDay = True
    End If
    
    Do While True
        sglTimeNow = Timer()
        If bSameDay = True Then
            If sglTimeNow >= sglTargetTime Then
                Exit Do
            End If
        Else
            ' Waiting for a time on the next day
            If sglLastTime > sglTimeNow Then
                ' rolled past midnight
                bSameDay = True
            Else
                sglLastTime = sglTimeNow
            End If
        End If
        ' Let other processes have a go with the CPU
        Sleep 100
        ' Process any messages
        DoEvents
    Loop

    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Sub

'-------------------------------------------------------------------------------
' FUNCTION: ParseCommand
'
' Parse a command string and get the next command token and it's associated
' value (if it has one).
'
' Command tokens must start with unique prefix character (default is '/').
' If the same character is used elsewhere in the command line then it must
' be prefixed as well (i.e. to have "c:/file" as an arg you must use "c://file").
' If a command token has a value then the items are separated by a
' colon (:)(i.e. /id:01).
'
' If a command value includes spaces then it must be enclosed in single quotes.
'
' Returns : CmdToken    - the command token (converted to lowercase) or "" if no
'                         token found
'           CmdValue    - the value associated with the command token or "" if
'                         no value
'           ParseCommand returns the remaining portion of the command string
'           If a command token cannot be found then the string is copied to CmdValue
'           and CmdToken and Parsecommand are set to "".
'-------------------------------------------------------------------------------
Public Function ParseCommand(CmdStr As String, CmdToken As String, CmdValue As String, _
    Optional CmdPrefix As String = "/") As String
Attribute ParseCommand.VB_Description = " Parse a command string and get the next command token and it's associated value (if it has one).\r\n\r\nCommand tokens must start with unique prefix character (default is '/'). If the same character is used elsewhere in the command line then it must be prefixed as well (i.e. to have ""c:/file"" as an arg you must use ""c://file""). If a command token has a value then the items are separated by a colon (:)(i.e. /id:01).\r\n\r\nIf a command value includes spaces then it must be enclosed in single quotes.\r\n\r\nReturns :\r\nCmdToken    - the command token (converted to lowercase) or """" if no token found\r\nCmdValue    - the value associated with the command token or """" if no value\r\nParseCommand returns the remaining portion of the command string. If a command token cannot be found then the string is copied to CmdValue and CmdToken and ParseCommand are set to """"."
Dim sTmp As String
Dim iCmdStart As Integer
Dim iCmdEnd As Integer
Dim iNextSpace As Integer
Dim iNextColon As Integer
Dim iNextCommand As Integer
Dim boolArgPresent As Boolean
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".ParseCommand"
   
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)


    'Strip off any leading spaces
    CmdStr = Trim$(CmdStr)
        
    iCmdStart = InStr(CmdStr, CmdPrefix)
    If iCmdStart = 0 Then
        'Command prefix not found so return the whole string as CmdValue
        CmdToken = vbNullString
        CmdValue = CmdStr
        ParseCommand = vbNullString

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceOut)

        Exit Function
    Else
        'Find the end of the command token (could be either ' ' (space) or ':')
        iNextSpace = InStr(2, CmdStr, " ")
        iNextColon = InStr(2, CmdStr, ":")
        If (iNextSpace = 0) And (iNextColon = 0) Then
            ' end of command token not found
            CmdToken = CmdStr
            CmdValue = vbNullString
            ParseCommand = vbNullString
        Else
            ' Determine whether we have a token with a value arg or not
            If iNextSpace = 0 Then
                boolArgPresent = True
            ElseIf iNextColon = 0 Then
                boolArgPresent = False
            ElseIf iNextColon < iNextSpace Then
                boolArgPresent = True
            Else
                boolArgPresent = False
            End If
        
            If boolArgPresent = True Then
                ' Colon is the end of command token
                ' Split out the command token
                CmdToken = LCase$(Left$(CmdStr, iNextColon - 1))
                ' Find the end of "value" portion of the command by looking for the
                ' start of the next command.
                iNextCommand = InStr(iNextColon + 1, CmdStr, CmdPrefix)
                If iNextCommand = 0 Then
                    ' End of string found so check for a space but
                    ' allow for quoted strings (e.g. 'My Documents')
                    If Mid$(CmdStr, iNextColon + 1, 1) = SINGLE_QUOTE Then
                        iNextCommand = InStr(iNextColon + 2, CmdStr, SINGLE_QUOTE)
                        If iNextCommand > 0 Then
                            ' Include closing single quote in the string
                            iNextCommand = iNextCommand + 1
                        End If
                    Else
                        iNextCommand = InStr(iNextColon + 1, CmdStr, " ")
                    End If
                End If
                If iNextCommand = 0 Then
                    CmdValue = Mid$(CmdStr, iNextColon + 1)
                Else
                    ' Next command token found - check that it is true command token
                    ' and not just a command separator embedded in the "value" portion
                    Do While Mid$(CmdStr, iNextCommand + 1, 1) = CmdPrefix
                        ' Remove 2nd coaamnd prefix character
                        sTmp = Left$(CmdStr, iNextCommand)
                        CmdStr = sTmp + Mid$(CmdStr, iNextCommand + 2)
                        iNextCommand = InStr(iNextCommand + 2, CmdStr, CmdPrefix)
                        If iNextCommand = 0 Then
                            ' End of string - so use the rest of the string
                            iNextCommand = Len(CmdStr) + 1
                            Exit Do
                        End If
                    Loop
                    ' Get the "value" of the command arg
                    CmdValue = Trim$(Mid$(CmdStr, iNextColon + 1, iNextCommand - iNextColon - 1))
                    ' Remove the single quotes from the string, if any
                    If Left$(CmdValue, 1) = SINGLE_QUOTE Then
                        CmdValue = Mid$(CmdValue, 2)
                    End If
                    If Right$(CmdValue, 1) = SINGLE_QUOTE Then
                        CmdValue = Left$(CmdValue, Len(CmdValue) - 1)
                    End If
                    ' Ready for processing the next call
                    ParseCommand = Mid$(CmdStr, iNextCommand)
                End If
            Else
                ' Space is the end of command token
                CmdToken = LCase$(Left$(CmdStr, iNextSpace - 1))
                CmdValue = vbNullString
                ParseCommand = Mid$(CmdStr, iNextSpace + 1)
            End If
        End If
    End If
    
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
        
End Function
'-----------------------------------------------------------
'<Auto-Procedure-Header>=======================================================================
' Function:  String BrowseForFolder()
'
' Description:
'   Displays a dialog that allows the user to select a directory from a tree.
'   This method has been superceded by "BrowseForFolderEx" and is only included for
'   compatibility.
'
'----------------------------------------------------------------------------------------------
' Arguments (Name, Type, Description):
' In:  Prompt   String = ""     - The prompt to display
'
' Out: Prompt   String = ""     - Not used as an output parameter.
'----------------------------------------------------------------------------------------------
' Returns:  String
'----------------------------------------------------------------------------------------------
' Version History (When, Who, What):
' 12/03/2001    davem
'               Header added.
' 12/03/2001    davem
'               Changed body of method to call BrowseForFolderEx
'</Auto-Procedure-Header>======================================================================
Public Function BrowseForFolder(Optional Prompt As String = vbNullString) As String
Attribute BrowseForFolder.VB_Description = "\r\nThis method have been superceeded by BrowseForFolderEx and is only maintained for backwards compatibility.\r\n\r\nDisplays a dialog (with an optional <Prompt>) that allows the user to select a directory from a tree.\r\nReturns the path to the selected directory or """" if Cancel is clicked."
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".BrowseForFolder"
   
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    BrowseForFolder = BrowseForFolderEx(0, Prompt)
   

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceOut)

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
        
End Function
'-----------------------------------------------------------
' FUNCTION: BrowseForFolder
'
' Displays a dialog that allows the user to select a directory from a tree
'
' Browse for a Folder using SHBrowseForFolder API function with a callback function
' BrowseCallbackProc.
'
' This Extends the functionality that was given in the MSDN Knowledge Base article
' Q179497 "HOWTO: Select a Directory Without the Common Dialog Control".
'
' See the MSDN knowledge base article Q179378 "HOWTO: Browse for Folders from the Current
' Directory" for more details.
'
' IN : [Owner]                  The hWnd of the parent form
'      [Prompt]                 Optional. Prompt to display on the Browse dialog
'      [StartFolder]            Optional. Folder to start browsing from. Defaults to the desktop
'      [StartFolderAsRoot]      Optional. The start folder is the root (user cannot browse
'                               above this folder). Defaults to True.
'      [IncludeNetworkFolders]  Optional. Include network folders in the browse.
'                               Defaults to False
'
' OUT :
'   The path selected, or "" if cancel was selected
'-----------------------------------------------------------
Public Function BrowseForFolderEx(ByVal OwnerHandle As Long, _
                                Optional ByVal Prompt As String = vbNullString, _
                                Optional ByVal StartFolder As String = vbNullString, _
                                Optional ByVal StartFolderAsRoot As Boolean = True, _
                                Optional ByVal IncludeNetworkFolders As Boolean = False) As String
Attribute BrowseForFolderEx.VB_Description = "\r\nDisplays a dialog that allows the user to select a directory from a tree.\r\nThe following parameters are used :\r\nOwner                           The hWnd of the parent form\r\nPrompt                            Optional. Prompt to display on the Browse dialog\r\nStartFolder                     Optional. Folder to start browsing from. Defaults to the desktop\r\nStartFolderAsRoot         Optional. The start folder is the root (user cannot browse  above this folder). Defaults to True.\r\nIncludeNetworkFolders  Optional. Include network folders in the browse.  Defaults to False\r\n\r\nReturns the path selected, or """" if cancel was selected"
Dim pidlList        As Long
Dim pidlRootFolder  As Long
Dim oShellFolder    As IVBShellFolder
Dim sBuffer         As String
Dim tBrowseInfo     As BrowseInfo
Dim sErrSource      As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".BrowseForFolderEx"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    ' Starting folder
    'pusStartFolder = StartFolder & vbNullChar
     pusStartFolder = StartFolder
     
    'Set up the BrowseInfo structure
    With tBrowseInfo
        
        ' Use BrowseCallbackProc() to set the starting folder in the Browse window
        ' and to update statustext on thw window.
        
        ' MarkBri 20/11/2001 Moved the callback function to the top because
        ' the callback was conflicting with the lstrcat statement. If this
        ' line is moved then the Title will not be displayed in the window.
        
        
        .lpcbCallback = GetAddressOfFunction(AddressOf BrowseCallbackProc)
        
        .hOwner = OwnerHandle
        .lpszTitle = lstrcat(Prompt, vbNullString)
        
        .ulFlags = BIF_RETURNONLYFSDIRS + BIF_STATUSTEXT
        If IncludeNetworkFolders = False Then
            ' Don't allow the use to select network folders
            .ulFlags = .ulFlags + BIF_DONTGOBELOWDOMAIN
        End If
        
        If StartFolderAsRoot = True Then
            ' Only want to select folders below the start folder
            If Len(StartFolder) > 0 Then
                ' Need to the ITEMIDLIST for the specified start folder.
                ' Get the DesktopFolder object
                Call SHGetDesktopFolder(oShellFolder)
                ' Convert the StartFolder to an ITEMIDLIST
                Call oShellFolder.ParseDisplayName(0, 0, StartFolder, 0, pidlRootFolder, 0)
                .pidlRoot = pidlRootFolder
                ' Release the DesktopFolder object
                Set oShellFolder = Nothing
            End If
        End If
        
        
    End With


    
    ' Show the Browse window and get the response
    pidlList = SHBrowseForFolder(tBrowseInfo)
    
    If (pidlList) Then
        ' A folder was selected so get it's path
        sBuffer = Space$(MAX_PATH)
        Call SHGetPathFromIDList(pidlList, sBuffer)
        sBuffer = StringFromBuffer(sBuffer)
        BrowseForFolderEx = sBuffer
    Else
        ' Cancel button clicked
        BrowseForFolderEx = vbNullString
    End If
  

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceOut)

    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    If Err.Number = -2147467259 Then
        ' Cannot get a valid IDLIST from ParseDisplayName
        Err.Clear
        Err.Raise 76, sErrSource
    Else
        Err.Raise Err.Number, sErrSource, Err.Description
    End If

End Function
'<Auto-Procedure-Header>=======================================================================
' Sub:  TranslateCaptions()
'
' Description:
'   Translate the captions for all controls on the form <Frm> and the form caption.
'   Captions are only translated if the control has the "Tag" property set to a number that
'   represents an index to a string in a RES file.
'   If a string does not exist in the RES file then leave the existing caption in place.
'
'   <ROOS> is used to get the string from the RES file and MUST support the <IResFile> interface.
'
'----------------------------------------------------------------------------------------------
' Arguments (Name, Type, Description):
' In:  Frm  Variant.
'      ROOS IResFile.
'----------------------------------------------------------------------------------------------
' Version History (When, Who, What):
' 13/03/2001    davem
'               Header added.
'</Auto-Procedure-Header>======================================================================
Public Sub TranslateCaptions(ByVal Frm As Variant, ByVal ROOS As IResFile)
Attribute TranslateCaptions.VB_Description = "Translate the captions for all controls on the form <Frm> and the form caption.\r\nCaptions are only translated if the control has the ""Tag"" property set to a number that represents an index to a string in a RES file."
Dim oControl    As Control
Dim oTab        As Variant
Dim lCount      As Long
Dim lTag        As Long
Dim lActiveTab As Long
Dim oCol        As Variant
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".TranslateCaptions"
    
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    ' Set the form caption
    If Len(Frm.Tag) > 0 Then
        Frm.Caption = ROOS.GetString(CLng(Frm.Tag), Frm.Caption)
    End If
    ' Loop through all the controls in the collection and set each one as necessary
    For Each oControl In Frm.Controls
        ' Determine if any special processing is needed for this control
        Select Case TypeName(oControl)
        Case "DataGrid"
            ' DatagGrid - so set the column headers.
            ' <Tag> represents the index for the 1st column, <Tag> + 1 for the 2nd column etc
            If Len(oControl.Tag) > 0 Then
                lTag = CLng(oControl.Tag)
                lCount = 0
                For Each oCol In oControl.Columns
                    oCol.Caption = ROOS.GetString(lTag + lCount, oCol.Caption)
                    lCount = lCount + 1
                Next oCol
            End If
        Case "ListView"
            ' ListView - so get the column headers
            ' Use the <Tag> on each column as the RES file index.
            For Each oCol In oControl.ColumnHeaders
                If Len(oCol.Tag) > 0 Then
                    oCol.Text = ROOS.GetString(oCol.Tag, oCol.Text)
                End If
            Next oCol
        Case "SSTab"
            ' TabDialog - so set the caption for each Tab
            ' <Tag> represents the index for the 1st Tab, <Tag> + 1 for the 2nd Tab etc
            If Len(oControl.Tag) > 0 Then
                lTag = CLng(oControl.Tag)
                lActiveTab = oControl.Tab
                lCount = 0
                Do While lCount < oControl.Tabs
                    oControl.Tab = lCount
                    oControl.Caption = ROOS.GetString(lTag + lCount, oControl.Caption)
                    lCount = lCount + 1
                Loop
                ' Make the correct Tab active
                oControl.Tab = lActiveTab
            End If
        Case "TabStrip"
            ' TabStrip - so set the caption for each Tab
            ' Use the <Tag> on each Tab as the RES file index.
            For Each oTab In oControl.Tabs
                If Len(oTab.Tag) Then
                    oTab.Caption = ROOS.GetString(CLng(oTab.Tag), oTab.Caption)
                End If
            Next oTab
        Case "TextBox"
            ' TextBox - so set the Text property
            If Len(oControl.Tag) > 0 Then
                oControl.Text = ROOS.GetString(CLng(oControl.Tag), oControl.Text)
            End If
        Case Else
            ' Standard control - so set the caption property
            If Len(oControl.Tag) > 0 Then
                oControl.Caption = ROOS.GetString(CLng(oControl.Tag), oControl.Caption)
            End If
        End Select
    Next oControl
    

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceOut)

    Exit Sub
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

End Sub
'-----------------------------------------------------------
' FUNCTION: GetAddressOfFunction
'
' Convert a value returned by the AddressOf operator on a procedure into a long.
' This is often required when using API calls.
'
' The procedure MUST be declared in a module and NOT a class.
'
' IN : [pcbAddress]     The address of a procedure returned by the AddressOf operator
'
' OUT :
'   The address as a long
'-----------------------------------------------------------
Private Function GetAddressOfFunction(ByVal pcbAddress As Long) As Long
Dim sErrSource As String

Const PROCEDURE_NAME As String = MODULE_NAME & ".GetAddressOfFunction"
   
    On Error GoTo GeneralErrorHandler

    Call DebugMsg(APP_NAME, PROCEDURE_NAME, endlTraceIn)

    
    GetAddressOfFunction = pcbAddress
   
    Exit Function
    
GeneralErrorHandler:

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description
            
End Function
'<Auto-Procedure-Header>=======================================================================
' Sub:  Class_Initialize()
'
' Description:
'   Populate the special folder, IsNT and OsVersion properties.
'   Disable logging.
'
'----------------------------------------------------------------------------------------------
' Arguments (Name, Type, Description):
' None.
'----------------------------------------------------------------------------------------------
' Version History (When, Who, What):
' 12/03/2001    davem
'               Created.
' 12/03/2001    davem
'               Removed "App.Title" from msObjectID
'</Auto-Procedure-Header>======================================================================
Private Sub Class_Initialize()
Dim osinfo      As OSVERSIONINFO
Dim iRetVal     As Integer
Dim lRet        As Long
Dim sTemp       As String * MAX_PATH
Dim sAction     As String
Dim PROCEDURE_NAME   As String
   
    msObjectID = "vbExt."
    PROCEDURE_NAME = msObjectID & "Class_Initialize"
        
    Call OutputDebugString(PROCEDURE_NAME & "-Starting")
    On Error GoTo GeneralErrorHandler

    ' Get the special folder names
    sAction = "Get Windows folder"
    lRet = GetWindowsDirectory(sTemp, MAX_PATH)
    If lRet > 0 Then
        mvarWindowsFolderName = Left$(sTemp, lRet)
    Else
        mvarWindowsFolderName = vbNullString
    End If
    
    sAction = "Get System folder"
    lRet = GetSystemDirectory(sTemp, MAX_PATH)
    If lRet > 0 Then
        mvarSystemFolderName = Left$(sTemp, lRet)
    Else
        mvarSystemFolderName = vbNullString
    End If
    
    sAction = "Get Temporary folder"
    mvarTempFolderName = Environ("TMP")
    
    ' Default values
    mltLogType = ltNoLog
    
    ' Get the O/S version number
    osinfo.dwOSVersionInfoSize = 148
    osinfo.szCSDVersion = Space$(128)
    sAction = "GetVersionEx"
    iRetVal = GetVersionEx(osinfo)
    
    sAction = "Parse version info"
    With osinfo
        Select Case .dwPlatformId
        Case 1
            ' Win95 or Win98 or ME
            Select Case .dwMinorVersion
            Case 0
                mvarOsVersion = Win95
            Case 10
                mvarOsVersion = Win98
            Case 90
                mvarOsVersion = WinME
            End Select
            mvarIsNT = False
            
        Case 2
            ' WinNT
            Select Case .dwMajorVersion
            Case 3
                mvarOsVersion = WinNT351
            Case 4
                mvarOsVersion = WinNT4
            Case 5
                mvarOsVersion = Win2K
            Case Else
                mvarOsVersion = 0
            End Select
            mvarIsNT = True
            
        Case Else
            mvarOsVersion = 0
            mvarIsNT = False
        End Select
    End With
    
    Exit Sub
    
GeneralErrorHandler:
Dim sErrSource As String

    If Err.Source = App.Title Then
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME
    ElseIf (InStr(Err.Source, STACK_ELEMENT_DELIMETER) = 1) Then
        'Err.Source already starts with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & Err.Source
    Else
        'Prefix Err.source with a stack delimiter
        sErrSource = STACK_ELEMENT_DELIMETER & PROCEDURE_NAME & STACK_ELEMENT_DELIMETER & Err.Source
    End If

    Err.Raise Err.Number, sErrSource, Err.Description

End Sub

